require 'spec_helper'

describe CueCloudRequest do

  let(:test_api_key) {'42cef2c79a984e34'}
  let(:test_api_pass) {'2152b0f3cc1649fb'}

  subject(:request) { CueCloudRequest.new(test_api_key, test_api_pass) }

  let(:request_with_invalid_credentials) { CueCloudRequest.new(test_api_key, "wrong_password") }
  let(:url) { CueCloudApi::DEFAULT_BASE_URL }

  describe '#build_request' do
    context "correct credentials" do
      it 'makes a success request' do
        expect(request.build_request('payments/', 'get')["StatusCode"]).to eq(200)
      end
    end
    context "invalid credentials" do
      it 'fails to make a call' do
        expect(request_with_invalid_credentials.build_request('payments/', 'get')["StatusCode"]).to eq(401)
      end
    end

    it "generates exception when an invalid method is passed" do
      expect { request.build_request('payments/', 'nonexisting') }.to raise_exception CueCloudException
    end

  end

end
